// WikiServer.h
//
// Wiki server class

class WikiServer : public Server
{
public:
	WikiServer(int port, FILE* logfd, const char* rootdir);
	~WikiServer();

	const char* GetServerName();
	int	Get(TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int	Post(TempFile& file, HTTP_RQ* rq, Headers& hdrs);

private:
	PageSet*	mPageSet;
	Page*		mEditPage;
	Page*		mDumpAllPages;
	Page*		mListAllPages;
	Page*		mRecentChanges;
	Page*		mReverseLink;

	int GetRaw(TempFile& file, const char* filename, const char* ext, Headers& hdrs);
	int	Cmd(Page* page, TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int	EditPage(TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int	DumpAllPages(TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int	ListAllPages(TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int RecentChanges(TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int ReverseLink(TempFile& file, HTTP_RQ* rq, Headers& hdrs);

	int SubmitPage(const char* pagename, TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int TitleSearch(const char* pagename, TempFile& file, HTTP_RQ* rq, Headers& hdrs);
	int FullSearch(const char* pagename, TempFile& file, HTTP_RQ* rq, Headers& hdrs);
};
