// headers.h
//
// header set

struct Header
{
	char*		mName;		// header name
	char*		mData;		// header data
	Header*		mNext;		// next header
};

class Headers
{
public:
	Headers();
	~Headers();

	// add a header
	void	AddHeader(const char* name, const char* data);

	// add headers from an HTTP request
	// (must not include first line)
	// the HTTP request *must* be properly terminated ([<CR>]<LF>[<CR>]<LF>)
	void	AddFromHTTP(const char* httprq);

	// add headers from a CGI string
	void	AddFromCGI(const char* cgistr);

	// find header
	const Header*	Find(const char* name) const;

	// count headers
	int		Count() const;

	// write out
	void	Write(FILE* fd) const;

private:
	Header*	mParms;
};
