// httprq.h
//
// HTTP_RQ object

#include "headers.h"

class HTTP_RQ
{
public:
	HTTP_RQ();
	~HTTP_RQ();

	void		AttachHeaders(char* hdr);
	void		AttachData(char* data, int len);

	// access
	const char*	GetReq() const		{ return _req; }
	const char*	GetURI() const		{ return _uri; }
	const char*	GetHTTPVer() const	{ return _httpv; }

	const char*	GetHeader(const char* hdrname) const;
	Headers*	GetURIData() const	{ return _uridata; }
	Headers*	GetPostData() const	{ return _postdata; }

	bool		ConvertGetToPost();

private:
	char*		_req;		// req name e.g. GET
	char*		_uri;		// URI name
	char*		_httpv;		// HTTP version

	Headers*	_hdrs;		// headers
	Headers*	_uridata;	// data from URI after ?
	Headers*	_postdata;	// data from post

	void		Destroy();
	void		Clear();

	bool		ValidateCommand();
};

const char* StatusLine(int status);
