// server.h
//
// abstract server class

#include <winsock2.h>

#include "httprq.h"
#include "tempfile.h"

class Server
{
public:
	Server(int port, FILE* logfd);
	virtual ~Server();

	void	Log(char* fmt, ...);

	void	Run();

	virtual const char*	GetServerName() = 0;
	virtual int		Get(TempFile& file, HTTP_RQ* rq, Headers& hdrs)		{ return 500; }
	virtual int		Post(TempFile& file, HTTP_RQ* rq, Headers& hdrs)	{ return 500; }

private:
	int				mPort;
	FILE*			mLog;

	void			CreateErrorPages();
	void			CreateErrorPage(int status, char* desc, char* verbiage);

	void			AddServerHeaders(Headers& hdrs);
	int				GetPort(SOCKET& s);
	void			HTTPError(SOCKET s, int status);
	HTTP_RQ*		ReadMessage(SOCKET s);
	void			RunCmd(SOCKET s, HTTP_RQ* rq);
};
