// tempfile.cpp
//
// temporary file

#include <stdio.h>
#include <stdlib.h>

#include <windows.h>

#include "utility.h"
#include "tempfile.h"

TempFile::TempFile(const char* tag)
{
	mTag = StringDup(tag);
	mFD = NULL;
}

TempFile::~TempFile()
{
	Close();

	char	fn[MAX_PATH];
	GetName(fn);

	DeleteFile(fn);
}

FILE* TempFile::Open(const char* perm)
{
	Close();

	char	fn[MAX_PATH];
	GetName(fn);

	mFD = fopen(fn, perm);
	
	return mFD;
}

void TempFile::Close()
{
	if (mFD)
	{
		fclose(mFD);
		mFD = NULL;
	}
}

void TempFile::GetName(char* fn)
{
	char	tp[256];
	GetTempPath(256, tp);

	sprintf(fn, "%s\\%s_%d.txt", tp, mTag, GetCurrentThreadId());
}
