// utility.h
//
// utilities

// StringSplit
//
// split text at character (at)
// frees text and returns new text buffer, plus new
// part buffer - user is responsible for freeing
// these buffers, and for not passing in static
// data!
#include <comdef.h>

char* StringSplit(char* text, char at, char*& part);

// StringDup
//
// duplicate string

char* StringDup(const char* str);
char* StringDup(const char* start, const char* end);

// URLEncode
// URLDecode
//
// encode/decode data from URL mapping
//
// functions delete input string and return new output buffer

void URLEncode(char*& data);
void URLDecode(char*& data);

// GetX
//
// decode an item from a string; return newly-allocated buffer
// and advance ls past the item's end

char* GetLine(const char*& ls);
char* GetAlphaNumeric(const char*& ls);
char* GetSquare(const char*& ls);
char* GetURL(const char*& ls);
char* GetNumber(const char*& ls);
char* GetISBN(const char*& ls, char rawisbn[11]);

void Utf8ToAscii(char*& data);
void AsciiToUtf8(char*& data);
// MonthName
//
// 1 = January, ..., 12 = December

const char* MonthName(int ix);

// MatchWildcardString
//
// see if a wildcard string is within another string

bool MatchWildcardString(const char* string, const char* search, bool recursing = false);
